
=// Declared Libraries for IR Sensor and Servo Motor
#include <IRremote.h> 
#include <Servo.h>

// Declared 7 segment display pins
int a =11; 
int b =10;
int c =7;
int d =8;
int e =9;
int f =12;
int g =13;
int receiverpin = 5; // Declared IR sensor pin 
int GreenLed = 4; // Declared GreenLed Pin
int RedLed = 3; // Declared RedLed Pin
int wiper = A5; // Declared wiper pin
int buzzer = 2; // Declared Buzzer pin
int PointUp = A0; // Declared PointUp pin
int PointDown = A1; // Declared PointDown pin
// Declared values which will be used later in this program
int delayvalue = 0; 
int sGameMessage = 0;
int counter = 0;
int pointgain = 0;
int lastpointgain = 0;
int pointloose = 0;
int lastpointloose = 0;
 
IRrecv irrecv(receiverpin); // Creates a variable of type IRrecv
decode_results results;

Servo myservo; // Declared Servo as myservo 

// Declaring void() for all the digits to be displayed on 7 segment display
void zero() // Display digit zero
{
  digitalWrite(a,LOW);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,LOW);
  digitalWrite(e,LOW);
  digitalWrite(f,LOW);
  digitalWrite(g,HIGH);
}

void one() // Display digit one
{
  digitalWrite(a,HIGH);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,HIGH);
  digitalWrite(e,HIGH);
  digitalWrite(f,HIGH);
  digitalWrite(g,HIGH);
}

void two() // Display digit two
{
  digitalWrite(a,LOW);
  digitalWrite(b,LOW);
  digitalWrite(c,HIGH);
  digitalWrite(d,LOW);
  digitalWrite(e,LOW);
  digitalWrite(f,HIGH);
  digitalWrite(g,LOW);
}

void three() // Display digit three
{
  digitalWrite(a,LOW);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,LOW);
  digitalWrite(e,HIGH);
  digitalWrite(f,HIGH);
  digitalWrite(g,LOW);
}

void four() // Display digit four
{
  digitalWrite(a,HIGH);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,HIGH);
  digitalWrite(e,HIGH);
  digitalWrite(f,LOW);
  digitalWrite(g,LOW);
}

void five() // Display digit five
{
  digitalWrite(a,LOW);
  digitalWrite(b,HIGH);
  digitalWrite(c,LOW);
  digitalWrite(d,LOW);
  digitalWrite(e,HIGH);
  digitalWrite(f,LOW);
  digitalWrite(g,LOW);
}

void six() // Display digit six
{
  digitalWrite(a,LOW);
  digitalWrite(b,HIGH);
  digitalWrite(c,LOW);
  digitalWrite(d,LOW);
  digitalWrite(e,LOW);
  digitalWrite(f,LOW);
  digitalWrite(g,LOW);
}

void seven() // Display digit seven
{
  digitalWrite(a,LOW);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,HIGH);
  digitalWrite(e,HIGH);
  digitalWrite(f,HIGH);
  digitalWrite(g,HIGH);
}

void eight() // Display digit eight
{
  digitalWrite(a,LOW);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,LOW);
  digitalWrite(e,LOW);
  digitalWrite(f,LOW);
  digitalWrite(g,LOW);
}

void nine() // Display digit nine
{
  digitalWrite(a,LOW);
  digitalWrite(b,LOW);
  digitalWrite(c,LOW);
  digitalWrite(d,HIGH);
  digitalWrite(e,HIGH);
  digitalWrite(f,LOW);
  digitalWrite(g,LOW);
}

void setup() //Void() that sets all the pins as either or INPUT or OUTPUT
{
  Serial.begin(9600);  
  irrecv.enableIRIn(); 
  myservo.attach(6);
  // Created For Loop to set all the pins for the 7 segment display as OUTPUT
  for (int i = 7; i<14; i++)
  {
  pinMode (i,OUTPUT);
  }
  pinMode(GreenLed, OUTPUT); // Set GreenLed as OUTPUT
  pinMode(RedLed, OUTPUT); // Set RedLed as OUTPUT
  pinMode(PointUp, INPUT); // Set PointUp as INPUT
  pinMode(PointDown, INPUT); // Set PointDown as INPUT
  pinMode(buzzer, OUTPUT); // Set as buzzer as OUTPUT
}
 
void changescore(int x) // User defined function with a parameter used to change the score on the 7 segment display
{
  switch(x)
  {
   default: 
       zero(); 
       break;
    
    case 1: 
       one(); 
       break;
    
    case 2:
       two(); 
       break;
    
    case 3:
       three(); 
       break;
    
    case 4: 
       four(); 
       break;
    
    case 5: 
       five(); 
       break;
    
    case 6: 
       six(); 
       break;
    
    case 7: 
       seven(); 
       break;
    
    case 8: 
       eight(); 
       break;
    
    case 9: 
       nine(); 
       break;
  }
}

void loop() // Here in this loop the code inside it will run repeatedly
{
  
  delayvalue = analogRead(wiper); // delayvalue will store the all the analog read values of the wiper
 
  while (sGameMessage==0)// While loop for the inital message, only displays once on the serial monitor 
  { 
    Serial.println("Welcome to the IR Servo Pointer Quiz Game");
    Serial.println("In this game you will answer some questions that you can design on your own and then play with your friends or family");
    Serial.println("You have to press these buttons on IR remote:");
    Serial.println(" ");
    Serial.println("Button 1 if the answer is correct to move the servo arm to the Green led and then press button 2 to return the servo arm to its initial position.");
    Serial.println("Button 3 if the answer is wrong to move the servo arm to the red led and then press button 4 to return the servo arm to its initial position.");
    Serial.println("Let's begin");
    sGameMessage++;
  }
  
      pointgain = digitalRead(PointUp); // pointgain will store all the digitalRead values of PointUp button
      pointloose = digitalRead(PointDown); // pointlosse will store all the digitalRead values of PointDown button
      
      if (pointgain != lastpointgain)
      {
        if(pointgain == HIGH) // If pointgain is pressed
        {
          if (counter == 9)
          {
            counter = 9;
          }
          counter ++; // counter will increment
          changescore(counter); // Display the score on 7 segment display
          delay(300); // Put the delay value of 300 to maitain the time of changing the digit on 7 segment display
        }
      }
     
   if (pointloose != lastpointloose) 
      {
        if(pointloose == HIGH) // pointloose is pressed
        {
          if (counter == 0)
          {
            counter = 0;
          }
          counter --; // counter will decrement
          changescore(counter); // Display the score on 7 segment display
          delay(300); // Put the delay value of 300 to maitain the time of changing the digit on 7 segment display
        }
      }changescore(counter);
 
  
 if (irrecv.decode(&results)) // Used to receive data from the receiver module.
   Serial.println(results.value, HEX); // Prints HEX values on the serial monitor.
   irrecv.resume(); // Receive the next value from the IR remote.
   
   if (results.value == 0XFD08F7) // If the results.value equals to 0XFD08F7 then
    {
      myservo.write(90); // move the servo arm to 90 degrees
      digitalWrite(GreenLed,HIGH); // turn GreenLed on
      delay(delayvalue); // Adjust the delayvalue using potentiometer to adjust the blinking affect
      digitalWrite(GreenLed,LOW); // again turn GreenLed on 
      delay(delayvalue); // Added the delay value to maitain a delay after every blink
    }
  
    else if (results.value == 0XFD8877)
    {
      myservo.write(0); // move the servo arm to 0 degrees
      digitalWrite(GreenLed,LOW); // Turn the GreenLed off
    }
  
  if (results.value == 0XFD48B7) // If the results.value equals to 0XFD48B7 then
    {
      myservo.write(180); // move the servo arm to 180 degrees
      digitalWrite(RedLed,HIGH); // turn RedLed on
      delay(delayvalue); // Adjust the delayvalue using potentiometer to adjust the blinking affect
      digitalWrite(RedLed,LOW); // again turn RedLed on 
      delay(delayvalue); // Added the delay value to maintain a delay after every blink
      digitalWrite(buzzer, HIGH); // Turn the buzzer on
      delay(delayvalue); // Added the delay time 
      digitalWrite(buzzer, LOW); // Turn the buzer off
      delay(delayvalue); // Added the delay time
    } 
  
   else if (results.value == 0XFD28D7) // If the results.value equals to 0XFD28D7 then
    {
      myservo.write(0); // move the servo arm to 0 degrees
      digitalWrite(RedLed,LOW); // Turn the RedLed off
      digitalWrite(buzzer, LOW); // Turn the buzzer off
    }
  
   else 
   
     myservo.write(0); // Else servo arm will remain at 0 degrees
     digitalWrite(GreenLed,LOW); // Else GreenLED will remain off
     digitalWrite(RedLed,LOW); // Else RedLed will remain off
     digitalWrite(buzzer, LOW); // Else buzzer will remain off 
}
